from flask import session
from flask import request, Blueprint, jsonify
from sqlalchemy import create_engine, select, MetaData, Table,text
from sqlalchemy.sql import and_, or_

from core import app

engine = create_engine(app.config['DATABASE_URI'],pool_pre_ping=True,pool_recycle=3600)

class BadgeModel():  
	def __init__(self):
		try:
			self.meta = MetaData()
			self.badge_role  = Table("badge_role",self.meta,autoload = True, autoload_with= engine)
			self.states    = Table("states", self.meta, autoload=True, autoload_with=engine)
			self.conference  = Table("conference",self.meta,autoload = True, autoload_with= engine) 
			self.delegates  = Table("delegates",self.meta,autoload = True, autoload_with= engine)
			
			
		except Exception as e:
			print(e)

	def GetConf(self,conf_id,conf_key):
		conn = engine.connect()
		# stmt = self.admin.select().where(self.admin.c.email.in_([email]))
		stmt = text("select * from conference where conf_id = "+str(conf_id)+" and conf_key = '"+conf_key+"'  limit 1;")
		results = conn.execute(stmt)
		result = results.fetchone()
		conn.close()
		if result : 
			return result
		else:
			return None 

	def get_states(self):
		stmt = select([self.states])
		stmt_2 = text("select * from states;")
		conn = engine.connect()
		result = conn.execute(stmt)
		conn.close()
		return result

	def checkUsername(self,username,conf_id):
		conn = engine.connect()
		stmt = text("select * from conference where conf_id = "+str(conf_id)+" and username = '"+username+"'   limit 1;")
		results = conn.execute(stmt)
		conn.close()
		results = [dict(r) for r in results] if results else None
		if results : 
			return results[0]
		else:
			return None 

	def AllRegUsers(self,conf_id,del_table_name) :
		conn = engine.connect()
		# stmt = text("select d.delegate_id,d.delegate_no,concat(ifnull(concat(d.prefix,' '),''),ifnull(d.full_name,''))  as full_name,d.email,d.mobile,d.city,d.state_id,d.counter,d.batch,d.role ,s.state_name  from "+del_table_name+" d left join states s on s.state_id = d.state_id inner join conference c on c.society_id = d.society_id where c.conf_id = " +str(conf_id)+"  and d.delegate_no > 0 order by delegate_no asc;")
		stmt = text("select d.delegate_id,d.delegate_no,d.full_name as full_name,d.email,d.mobile,d.city,d.state, d.counter,d.batch,d.role,d.company_name  from  "+del_table_name+"  d where d.delegate_no > 0 order by delegate_no asc;") 
		results = conn.execute(stmt)
		conn.close()
		results = results.fetchall()
		if results : 
			return results
		else:
			return None     

	def AllDelegageIds(self,conf_id,del_table_name) :
		conn = engine.connect()
		#stmt = text("select d.delegate_no from delegates d left join states s on s.state_id = d.state_id inner join conference c on c.society_id = d.society_id where c.conf_id = " +str(conf_id)+"  and d.delegate_no > 0 order by delegate_no asc;")
		stmt  = text("select  distinct (d.delegate_no) from "+del_table_name+" d where d.delegate_no is not null and d.delegate_no > 0 order by delegate_no asc;")
		results = conn.execute(stmt)
		conn.close()
		results = [dict(r) for r in results] if results else None
		if results : 
			return results
		else:
			return None 


	def updateCouterBatch(self,update_query):
		conn    = engine.connect()
		try:
			stmt        = text(update_query)
			safe_update = text("SET SQL_SAFE_UPDATES = 0 ")
			result      = conn.execute(safe_update)
			results     = conn.execute(stmt)
			conn.close()
			
			return "success"
		except Exception as e:
			conn.close()
			return str(e)
			# raise e

	# Multiple result set store proc function
	def GetBatchCounterRole(self,conf_id,del_table_name):
		sets = []
		try:
			connection = engine.raw_connection()
			cursor = connection.cursor()
			cursor.callproc("usp_counter_batch_role",[conf_id,del_table_name])
			while 1:
				names = [c[0] for c in cursor.description]
				set_ = []
				while 1:
					row_raw = cursor.fetchone()
					if row_raw is None:
						break
						
					row = dict(zip(names, row_raw))
					set_.append(row)
	 
				sets.append(list(set_))
	 
				if cursor.nextset() is None:
					break
	 
				# nextset() doesn't seem to be sufficiant to tell the end.
				if cursor.description is None:
					break
		finally:
			# Return the connection to the pool (won't actually close).
			connection.commit()
			connection.close()
			
		return sets 

	def dataForBadgePrint(self,conf_id,role,counter,batch,del_no_from,del_no_to,del_table_name,is_commitment = None):
		connection = engine.raw_connection()
		cursor = connection.cursor()
		cursor.callproc("usp_delegate_badge_data",[conf_id,role,counter,batch,del_no_from,del_no_to,del_table_name,is_commitment])
		
		if cursor.description :
			columns = [column[0] for column in cursor.description]
			results = []
			for row in cursor.fetchall():
				results.append(dict(zip(columns, row)))
			cursor.close()
			connection.commit()
			if results :
				return results
			else :
				return None
		else :
			cursor.close()
			connection.commit()
			return None 
			
	def dataForBadgePrintDelNos(self,conf_id,role,counter,batch,del_nos,del_table_name,is_kit):
		connection = engine.raw_connection()
		cursor = connection.cursor()
		cursor.callproc("usp_delegate_badge_data_customids_withkit",[conf_id,role,counter,batch,del_nos,del_table_name,is_kit])
		
		if cursor.description :
			columns = [column[0] for column in cursor.description]
			results = []
			for row in cursor.fetchall():
				results.append(dict(zip(columns, row)))
			cursor.close()
			connection.commit()
			if results :
				return results
			else :
				return None
		else :
			cursor.close()
			connection.commit()
			return None             
					

	def EditRegisteredData(self,conf_id,delegate_id,del_table_name):
		conn = engine.connect()
		# stmt = text("select d.delegate_id,d.delegate_no,concat(ifnull(concat(d.prefix,' '),''),ifnull(d.full_name,''))  as full_name,d.email,d.city,d.state_id,s.state_name from delegates d left join states s on d.state_id=s.state_id  where d.delegate_id = "+str(delegate_id)+" and conference_id="+str(conf_id)+" ;")
		stmt = text("select d.* from  "+del_table_name+"  d   where d.delegate_id = "+str(delegate_id)+"  ;")
		results = conn.execute(stmt)
		conn.close()
		result = results.fetchone()
		if result : 
			return result
		else:
			return None 



	def UpdateDelegates(self,update_stmt,delegate_id,conf_id):
		conn        = engine.connect()
		safe_update = text("SET SQL_SAFE_UPDATES = 0 ; ")
		result_1    = conn.execute(safe_update)
		stmt        = text(update_stmt) 
		# stmt = self.delegates.update().where(self.delegates.c.delegate_id.in_([delegate_id])).values(data)
		result = conn.execute(stmt)
		conn.close()
		if result:
			return result
		else :
		   return None


	def check_email_for_update(self,email,delegate_id,del_table_name):
		conn = engine.connect()
		stmt = text("select count(*) as email_count from "+del_table_name+" where email = " + "'" + email + "'" + "and delegate_id !=" + str( delegate_id) + ";")
		result = conn.execute(stmt)
		conn.close()
		results = [dict(r) for r in result] 
		# if result else None
		if results :
			return results[0]
		else:
			return None     


	def GetDelegates(self):
		conn = engine.connect()
		stmt = text("select d.delegate_id,d.delegate_no,concat(ifnull(concat(d.prefix,' '),''),ifnull(d.full_name,''))  as full_name,d.email,d.city,s.state_name,d.counter,d.batch,d.role from delegates d  left join states s on d.state_id=s.state_id  where  delegate_no > 0 limit 20; ")
		results = conn.execute(stmt)
		conn.close()
		result = [dict(r) for r in results] if results else None
		if result : 
			return result
		else:
			return None 

	# Nov 03 2022
	def delegateMoveToConfDelegate(self,conference_id,conf_del_table,max_del_no,current_dt):
		conn                  = engine.connect()
		check_no_records_stmt = text("SELECT count(*) as no_of_records from delegates where delegate_no > 0 and conference_id = "+str(conference_id)+"  and delegate_no is not null and delegate_no not in (select delegate_no from "+conf_del_table+") ")
		# check_no_records_stmt = text("SELECT count(*) as no_of_records  from delegates where delegate_no > "+str(max_del_no)+ "  and conference_id = "+str(conference_id)+ " and delegate_no is not null")
		# check_no_records_stmt = text("SELECT count(*) as no_of_records from delegates where delegate_no > 0 and delegate_no is not null and delegate_no not in (select delegate_no from "+conf_del_table+") ")
		results               = conn.execute(check_no_records_stmt)
		result = [dict(r) for r in results] if results else None
		if result :
			no_of_records = result[0]['no_of_records']

			if no_of_records > 0 :
				#stmt  = text("insert into "+conf_del_table+" (delegate_no ,conf_id,full_name,email,mobile,city,membership_no,created_at,state,role,company_name) "
				# + " select delegate_no,conference_id,concat(ifnull(concat(prefix,' '),''),ifnull(full_name,''))  as full_name ,email,mobile,city,"
				# +" membership_no , '"+current_dt+"' , s.state_name,role,d_company_name from delegates left join states s on delegates.state_id = s.state_id where conference_id = "+str(conference_id)+" and delegate_no is not null  and delegate_no > "+str(max_del_no)+"  and delegate_no not  in ( select delegate_no from "+conf_del_table+" );")
				#### stmt update on Jan 05, 2023 for prevent duplicate record insert 
				
				stmt  = text("insert into "+conf_del_table+" (user_id,delegate_no ,conf_id,full_name,email,mobile,city,membership_no,mc_number,created_at,state,role,company_name) "
				+ " select user_id, delegate_no,conference_id,concat(ifnull(concat(prefix,' '),''),ifnull(full_name,''))  as full_name ,email,mobile,city,"
				+" membership_no ,mc_number, '"+current_dt+"' , s.state_name,role,d_company_name from delegates left join states s on delegates.state_id = s.state_id where conference_id = "+str(conference_id)+" and delegate_no is not null and delegate_no > 0 and delegate_no not  in ( select delegate_no from "+conf_del_table+" );")
				result = conn.execute(stmt)
				conn.close()
				return  str(no_of_records) +" records are successfully moved."
			else :
				conn.close()
				return "There is no new records exists."     
		else : 
			conn.close()
			return "There is no new records exists."    
		

	def getMaxDelegateNo(self,conf_del_table):
		conn = engine.connect()
		stmt = text("select max(delegate_no) as delegate_no from  "+conf_del_table+" where delegate_no > 5000 limit 1;")
#       stmt = text("select max(delegate_no) as delegate_no from  "+conf_del_table+" where delegate_no < 3000 limit 1;")
		result = conn.execute(stmt)
		results = [dict(r) for r in result] if result else None
		conn.close()
		if results :
			return results[0]
		else:
			return None 
			
	# nov 07 2022
	def getRole(self,conf_id):
		conn = engine.connect()
		stmt = text("select * from badge_role where conf_id = "+str(conf_id)+";")
		result = conn.execute(stmt)
		results = [dict(r) for r in result] if result else None
		conn.close()
		if results :
			return results
		else:
			return None 
	#nov 17 22 Siva &*****************************************************************
	def insertEmptyRecords(self,insert_query):
		conn    = engine.connect()
		try:
			stmt        = text(insert_query)
			print(stmt)
			results     = conn.execute(stmt)
			conn.close()
			
			return "success"
		except Exception as e:
			conn.close()
			return str(e)
			
	# Nov 22 ,2022 updated by Ganesan J on
	#sessionMap(conf_id,del_id_int,session_table,del_ses_table)
	def sessionMap(self,conf_id,del_id_int,session_table,del_ses_table) :
		connection = engine.raw_connection()
		cursor = connection.cursor()
		cursor.callproc("usp_delegate_session_map",[conf_id,del_id_int,session_table,del_ses_table])
		
		if cursor.description :
			columns = [column[0] for column in cursor.description]
			results = []
			for row in cursor.fetchall():
				results.append(dict(zip(columns, row)))
			cursor.close()
			connection.commit()
			if results :
				return results
			else :
				return None
		else :
			cursor.close()
			connection.commit()
			return None 
			
	# Nov 23 update is_exhibitor s
	def updateExhibitor(self,update_query):
		conn    = engine.connect()
		try:
			stmt        = text(update_query)
			safe_update = text("SET SQL_SAFE_UPDATES = 0 ")
			result      = conn.execute(safe_update)
			results     = conn.execute(stmt)
			conn.close()
			
			return "success"
		except Exception as e:
			conn.close()
			return str(e)
			
	#moveSpotRegintoFoodSession
	def moveSpotRegintoFoodSession(self,session_id) : 
		conn = engine.connect()
		stmt = text("insert into fc_delegates_sessions_irc22 (session_id,delegate_no) select "+str(session_id)+", delegate_no from delegates_irc22  where delegate_no > (select  ifnull(max(delegate_no), 0)  as delegate_no from fc_delegates_sessions_irc22); ")
		result = conn.execute(stmt)
		conn.close()
		if result:
			return 'success'
		else :
		   return 'fail'	
		   
	# Dec 05,2022
	# Role Option start -----------------------
	def deleteBadgeRole(self,b_role_id):
		conn = engine.connect()
		stmt = self.badge_role.delete().where(self.badge_role.c.b_role_id.in_([b_role_id]))
		result = conn.execute(stmt)
		conn.close()
		return result

	def insertBadgeRole(self,data):
		conn = engine.connect()
		result = conn.execute(self.badge_role.insert(), data)
		conn.close()
		return result

	def updateBadgeRole(self,b_role_id,data):
		conn = engine.connect()
		# stmt = text("update badge_role set b_role = '"+role+"'  where b_role_id  = "+str(b_role_id)+" ;")
		stmt = self.badge_role.update().where(self.badge_role.c.b_role_id.in_([b_role_id])).values(data)
		print(stmt)
		result = conn.execute(stmt)
		conn.close()
		if result:
			return 'success'
		else :
		   return 'fail'	

#Role option End--------------------------
		
	
		
################### For Digital Batch   ###############
# Created by : Priyavarthana
# 2022-12-07

	def check_email_mobile(self,del_table_name,email_mobile,conf_id):
		conn = engine.connect()
		stmt = text("select * from "+del_table_name+" where conf_id =:conf_id and (email =:email_mobile or mobile=:email_mobile)  order by role desc;")
		result = conn.execute(stmt,conf_id=conf_id,email_mobile=email_mobile)
		results = [dict(r) for r in result] if result else None
		conn.close()
		if results:
			return results
		else :
			return None  




	def update_delegate(self,del_table_name,delegate_id,updated_at,otp_verify_on):
		conn = engine.connect()
		stmt = text("update "+del_table_name+" set updated_at= '"+str(updated_at)+"', otp_verify_on= '"+str(otp_verify_on)+"', otp = null where  delegate_id =" + str( delegate_id) + ";")
		result = conn.execute(stmt)
		conn.close()
		if result:
			return 'success'
		else :
		   return 'fail'
	def getDelegateByID(self,del_table_name,delegate_id):
		conn = engine.connect()
		stmt = text("select * from "+del_table_name+" where  delegate_id= :delegate_id;")
		results = conn.execute(stmt,delegate_id=delegate_id)
		results = results.fetchone()
		conn.close()
		if results :
			return dict(results)
		else:
			return None
	
	
################### END For Digital Batch   ###############	
	
# Dec 23,2022  Siva Balan 
	def get_role_count(self,conf_id,del_table_name):
		conn = engine.connect()
		stmt = text("SELECT role,count(delegate_no) as del_count  from "+del_table_name+"   group by role order by role;")
		result = conn.execute(stmt)
		results = [dict(r) for r in result] if result else None
		conn.close()
		if results :
			return results
		else:
			return None	

	def usp_delegates_session_map(self,role,session_id,del_table_name,del_session_table_name):
		connection  = engine.raw_connection()
		cursor      = connection.cursor()
		cursor.callproc("usp_insert_delegate_sessions_map",[role,session_id,del_table_name,del_session_table_name])
		if cursor.description :
			columns     = [column[0] for column in cursor.description]
			results     = []
			for row in cursor.fetchall():
				results.append(dict(zip(columns, row)))
			cursor.close()
			connection.commit()
			if results :
				return results
			else :
				return None
		else :
			cursor.close()
			connection.commit()
			return None	

# Dec 24,2022  Siva Balan 
	def delete_sessiondata(self,role,session_id,del_table_name,del_session_table_name):
		conn = engine.connect()
		stmt = text("Delete from "+del_session_table_name+"  where delegate_no  in (select  delegate_no from "+del_table_name+"  where role = ('"+role+"') )and session_id=" + str( session_id) + ";")
		safe_update = text("SET SQL_SAFE_UPDATES = 0 ")
		results= conn.execute(safe_update)
		result = conn.execute(stmt)
		conn.close()
		return result		
	
	def get_uuid_delegates(self,del_table_name,uuid,conf_id):
		conn = engine.connect()
		stmt = text("select t.* from delegates_boa23 t " 
						+ " inner join delegates d on t.delegate_no = d.delegate_no and d.conference_id = :conf_id " 
						+ " inner join users u on u.user_id = d.user_id or u.user_id = d.parent_user_id " 
						+ " where u.user_uuid = :uuid")
		result = conn.execute(stmt,conf_id=conf_id,uuid=uuid)
		results = [dict(r) for r in result] if result else None
		conn.close()
		if results:
			return results
		else :
			return None  

	
	def update_delegate_otp(self,del_table_name,delegate_id,updated_at,otp):
		conn = engine.connect()
		stmt = text("update "+del_table_name+" set updated_at= '"+str(updated_at)+"', otp= '"+str(otp)+"' where  delegate_id =" + str( delegate_id) + ";")
		result = conn.execute(stmt)
		conn.close()
		if result:
			return 'success'
		else :
		   return 'fail'		
	
	

	


