from flask import Flask,render_template,request
from flask_session import Session
import os,time
import datetime
from datetime import timedelta,date,datetime
import traceback
import logging
# from flask_qrcode import QRcode
app = Flask(__name__)
# qrcode = QRcode(app)


app.config.from_object('core.config.SECRET_KEY')
app.config.from_object('core.config.ProductionConfig')

Session(app)

os.environ['TZ'] ='Asia/Calcutta'
time.tzset()

path_wkhtmltopdf = "C:/Program Files/wkhtmltopdf/bin/wkhtmltopdf.exe"
is_windows_os    = 0


# for command prompt text clear
# logging.getLogger('werkzeug').disabled = True
# os.environ['WERKZEUG_RUN_MAIN'] = 'true'


config = app.config
from core.library.auth import Auth
from core.library.route_group import RouteGroup
from core.library.cryptography import Cryptography
from core.library.helper import Helper
from core.library.custom import Custom
from core.model.Log import Log

current_app = app

#from core import routes

# ganesan
from core.controller.KitSessionController import app as kit_session
app.register_blueprint(kit_session, url_prefix='')

from core.controller.KitController import app as kit
app.register_blueprint(kit, url_prefix='')

from core.controller.FoodSessionController import app as food_session
app.register_blueprint(food_session, url_prefix='')

from core.controller.FCController import app as fc
app.register_blueprint(fc, url_prefix='')

from core.controller.BadgeUserController import app as badge_user
app.register_blueprint(badge_user, url_prefix='')

from core.controller.BadgeController import app as badge
app.register_blueprint(badge, url_prefix='')

from core.controller.RegDeskController import app as regdesk
app.register_blueprint(regdesk, url_prefix='')

from core.controller.SignupController import app as signup
app.register_blueprint(signup, url_prefix='')

from core.controller.HallLogsController import app as halllogs
app.register_blueprint(halllogs, url_prefix='')

from core.controller.BOHallLogsController import app as bohalllogs
app.register_blueprint(bohalllogs, url_prefix='')

from core.controller.QueryController import app as query
app.register_blueprint(query, url_prefix='')

from core.controller.BOQueryController import app as boquery
app.register_blueprint(boquery, url_prefix='')

from core.controller.CurrentSessionController import app as currentsession
app.register_blueprint(currentsession, url_prefix='')

from core.controller.AttendanceController import app as attendance
app.register_blueprint(attendance, url_prefix='')

from core.controller.DigitalBatchController import app as digitalbatch
app.register_blueprint(digitalbatch, url_prefix='')
###

# Dec 23 ,2022
from core.controller.CertificateController import app as cert
app.register_blueprint(cert, url_prefix='')
###

# Jan 12 ,2023 # 
from core.controller.ConferenceController import app as conf
app.register_blueprint(conf, url_prefix='')

# For BOA 2023 
from core.controller.NotificationController import app as notification
app.register_blueprint(notification, url_prefix='')

# Santhosh May 12 ,2023
from core.controller.ConfAppController import app as confapp
app.register_blueprint(confapp, url_prefix='')

from core.controller.UserController import app as userss
app.register_blueprint(userss, url_prefix='')

# Santhosh june 05 ,2023
from core.controller.OfflineRegistrationController import app as offline_reg
app.register_blueprint(offline_reg, url_prefix='')

#Aravinth June 14 ,2023
from core.controller.AddonController import app as addons
app.register_blueprint(addons, url_prefix='')

# Ramya July 07 , 2023
from core.controller.BOReportController import app as boreport
app.register_blueprint(boreport, url_prefix='')

# webcamera
from core.controller.WebCameraController import app as webcamera
app.register_blueprint(webcamera, url_prefix='')

# venue_scan
from core.controller.VenueScanController import app as venue_scan
app.register_blueprint(venue_scan, url_prefix='')

# Transaction 
from core.controller.TransactionAPIController import app as transapi
app.register_blueprint(transapi, url_prefix='')

from core.controller.FirebaseController import app as firebase
app.register_blueprint(firebase, url_prefix='')

@app.errorhandler(404)
def page_not_found(e):
	return render_template('404.html'), 404


class SQLAlchemyHandler(logging.Handler):
	def emit(self, record):
		trace = None
		exc = record.__dict__['exc_info']
		if exc:
			trace = traceback.format_exc()

		path    = request.path
		method  = request.method
		ip      = request.remote_addr

		data = {
				'url'           : path,
				'logger_name'   : record.__dict__['name'],
				'level'         : record.__dict__['levelname'],
				'context'       : trace,
				'message'       : record.__dict__['msg'],
				'created_at'    : datetime.now(),
				'ip_address'    : ip,
				'user_id'       : Auth.user().get('user_id',None) if Auth.user() else None,
				'app_type'      : Helper.AppType,
				'host_url'      : request.host
				}    
		Log().insert(data)    
		# log = Log(
		#     logger=record.__dict__['name'],
		#     level=record.__dict__['levelname'],
		#     trace=trace,
		#     msg=record.__dict__['msg'],)
		# DB.session.add(log)
		# DB.session.commit()

logger = logging.getLogger(__name__)
logger.setLevel(logging.INFO)

ch = SQLAlchemyHandler()
ch.setLevel(logging.INFO)

formatter = logging.Formatter('%(asctime)s - %(name)s - %(levelname)s - %(message)s')
ch.setFormatter(formatter)
loggers = [logger, logging.getLogger('sqlalchemy'), logging.getLogger('flask.app')]

for l in loggers:
	l.addHandler(ch)


@app.errorhandler(404)
def page_not_found(e):
	return render_template('users/404.html'),404


@app.errorhandler(500)
def page_not_found(e):  
	return render_template('users/500.html'),500