from flask import Flask, request, Blueprint, jsonify, redirect, url_for,flash, render_template,session,json
import datetime
from datetime import timedelta,date,datetime
from flask import session, app
from .. import Cryptography,Auth,RouteGroup,Helper
from core.model.HallLogsModel import HallLogsModel
from core.model.BadgeModel import BadgeModel
import base64
from urllib.parse import unquote
from dateutil.rrule import rrule, DAILY

app = Blueprint('bohalllogs', __name__)


@app.route('/<int:conf_id>/<conf_key>/hall_bologin', methods = ["GET", "POST"])
def HallBOLogin(conf_id,conf_key):
	try:
		conf_data  = BadgeModel().GetConf(conf_id,conf_key)
		conf_name  = conf_data['conf_name']
		return render_template('hall_logs/hall_bologin.html',conf_id=conf_id,conf_key=conf_key,conf_data=conf_data,conf_name=conf_name)
	except Exception as e:
		print(e)
		raise e
	
	
@app.route('/<int:conf_id>/<conf_key>/post_hall_bologin', methods = ["GET", "POST"])
def postHallBOLogin(conf_id,conf_key):
	if request.method == 'POST':
		username  = request.form['username']
		password  = request.form['password']
		get_conf  = BadgeModel().checkUsername(username,conf_id)
		if get_conf : 
			db_pass =  get_conf['badge_login_password']
			if password == db_pass:
				admin_id = get_conf['conf_id']
				session['bohallsession']   =  get_conf
				return redirect (url_for('bohalllogs.BOHallDashboard',conf_id=conf_id ,conf_key = conf_key))
			else:
				flash("Password is mismatch" , "errorMsg")
				return redirect (url_for('bohalllogs.HallBOLogin',conf_id=conf_id ,conf_key= conf_key))
		else:
			flash("Username is not registered." , "errorMsg")
			return redirect (url_for('bohalllogs.HallBOLogin',conf_id=conf_id ,conf_key= conf_key))
	else :
		return "Method not allowed"			

@app.route('/<int:conf_id>/<conf_key>/bo_hall_dashboard', methods = ["GET", "POST"])
def BOHallDashboard(conf_id,conf_key):
	if session.get("bohallsession") :
		get_conf  = BadgeModel().GetConf(conf_id,conf_key)
		if get_conf :
			start_date = get_conf['conf_start_time']
			end_date   = get_conf['conf_end_time']
			conf_name  = get_conf['conf_name']
			confe_date = []
			now = datetime.now()
			current_date = now.strftime('%Y-%m-%d')
			for dt in rrule(DAILY, dtstart=start_date, until=end_date):
				confe_date.append(dt.strftime("%Y-%m-%d"))
		return render_template('hall_logs/hall_bodashboard.html',conf_id=conf_id,conf_key=conf_key,confe_date=confe_date,current_date=current_date,conf_name=conf_name)
	else :
		return "Session Expired"	


@app.route('/<int:conf_id>/<conf_key>/hall_scan_daywise', methods = ["GET", "POST"])
def BOHallScanDaywise(conf_id,conf_key):
	if session.get("bohallsession") :
		get_conf  = BadgeModel().GetConf(conf_id,conf_key)
		if get_conf :
			start_date = get_conf['conf_start_time']
			end_date   = get_conf['conf_end_time']
			conf_name  = get_conf['conf_name']
			confe_date = []
			now = datetime.now()
			current_date = now.strftime('%Y-%m-%d')
			for dt in rrule(DAILY, dtstart=start_date, until=end_date):
				confe_date.append(dt.strftime("%Y-%m-%d"))
		getHalls  = HallLogsModel().gethallsname(conf_id)
		return render_template('hall_logs/hall_scan_daywise.html',conf_id=conf_id,conf_key=conf_key,confe_date=confe_date,getHalls=getHalls)
	else :
		return "Session Expired"	

@app.route('/<int:conf_id>/<conf_key>/get_hall_daywise_report', methods = ["GET", "POST"])
def BOGetHallDaywiseReport(conf_id,conf_key):
	if session.get("bohallsession") :
		abs_hall_id  = request.values.get('abs_hall_id')
		current_date = request.values.get('conf_date')
		cr_date      = datetime.strptime(current_date, '%Y-%m-%d')
		current_date = cr_date.strftime("%d")
		current_date = int(current_date)
		report_data  = HallLogsModel().gethallreportHallsModel(conf_key,abs_hall_id,current_date)
		html_data      = render_template('hall_logs/hall_report_table_v1.html',hallData=report_data,conf_id=conf_id,conf_key=conf_key)
		data           = { 'status': 1,'html':html_data}
		json_data      = json.dumps(data,default=str)
		return json_data

	else :
		return "Session Expired"

@app.route('/<int:conf_id>/<conf_key>/hall_scan_sessionwise', methods = ["GET", "POST"])
def BOHallScanSessionwise(conf_id,conf_key):
	if session.get("bohallsession") :
		get_conf  = BadgeModel().GetConf(conf_id,conf_key)
		if get_conf :
			start_date = get_conf['conf_start_time']
			end_date   = get_conf['conf_end_time']
			conf_name  = get_conf['conf_name']
			confe_date = []
			now = datetime.now()
			current_date = now.strftime('%Y-%m-%d')
			for dt in rrule(DAILY, dtstart=start_date, until=end_date):
				confe_date.append(dt.strftime("%Y-%m-%d"))
		getHalls  = HallLogsModel().gethallsname(conf_id)
		
		return render_template('hall_logs/hall_scan_sessionwise.html',conf_id=conf_id,conf_key=conf_key,confe_date=confe_date,getHalls=getHalls)
	else :
		return "Session Expired"	


@app.route('/<int:conf_id>/<conf_key>/get_hall_sessionwise_report', methods = ["GET", "POST"])
def BOGetHallSessionwiseReport(conf_id,conf_key):
	if session.get("bohallsession") :
		abs_hall_id  = request.values.get('abs_hall_id')
		current_date = request.values.get('conf_date')
		cr_date      = datetime.strptime(current_date, '%Y-%m-%d')
		current_date = cr_date.strftime("%d")
		current_date = int(current_date)
		report_data = HallLogsModel().gethallsessionreportHallsModel(conf_key,abs_hall_id,current_date)
		html_data      = render_template('hall_logs/hall_session_report_table_v1.html',hallData=report_data,conf_id=conf_id,conf_key=conf_key)
		data           = { 'status': 1,'html':html_data}
		json_data      = json.dumps(data,default=str)
		return json_data

	else :
		return "Session Expired"

@app.route('/<int:conf_id>/<conf_key>/hall_scan_overall_session', methods = ["GET", "POST"])
def BOHallScanOverallSession(conf_id,conf_key):
	if session.get("bohallsession") :
		get_conf  = BadgeModel().GetConf(conf_id,conf_key)
		# HallLogsModel().usp_get_overall_session_wise_report(conf_id,conf_key)
		if get_conf :
			start_date = get_conf['conf_start_time']
			end_date   = get_conf['conf_end_time']
			conf_name  = get_conf['conf_name']
			confe_date = []
			now = datetime.now()
			current_date = now.strftime('%Y-%m-%d')
			for dt in rrule(DAILY, dtstart=start_date, until=end_date):
				confe_date.append(dt.strftime("%Y-%m-%d"))
		
		return render_template('hall_logs/hall_scan_overall_session.html',conf_id=conf_id,conf_key=conf_key,confe_date=confe_date)
	else :
		return "Session Expired"	


@app.route('/<int:conf_id>/<conf_key>/get_hall_overallsession_report', methods = ["GET", "POST"])
def BOGetHallOverallSessionReport(conf_id,conf_key):
	if session.get("bohallsession") :
		current_date = request.values.get('conf_date') or None
		if current_date:
			cr_date      = datetime.strptime(current_date, '%Y-%m-%d')
			current_date = cr_date.strftime("%d")
			current_date = int(current_date)
		else:
			current_date = None
		report_data = HallLogsModel().usp_get_overall_session_wise_report(conf_id,conf_key,current_date)

		html_data      = render_template('hall_logs/hall_overall_session_report_table.html',hallData=report_data,conf_id=conf_id,conf_key=conf_key)
		data           = { 'status': 1,'html':html_data}
		json_data      = json.dumps(data,default=str)
		return json_data

	else :
		return "Session Expired"


@app.route('/<int:conf_id>/<conf_key>/hall_scan_delgate_report', methods = ["GET", "POST"])
def BOHallDelegateReport(conf_id,conf_key):
	if session.get("bohallsession") :
		# get_conf  = BadgeModel().GetConf(conf_id,conf_key)
		delegateData = HallLogsModel().usp_get_overall_delegate_report(conf_id,conf_key);
		return render_template('hall_logs/hall_scan_delgate_report.html',conf_id=conf_id,conf_key=conf_key,data=delegateData)
	else :
		return "Session Expired"

# call usp_get_delegate_session_wise_report(17,'tnoa23',date,delegate_no);

@app.route('/<int:conf_id>/<conf_key>/hall_scan_delegate_sessionwise', methods = ["GET", "POST"])
def BOHallScanDelegateSessionwise(conf_id,conf_key):
	if session.get("bohallsession") :
		get_conf  = BadgeModel().GetConf(conf_id,conf_key)
		if get_conf :
			start_date = get_conf['conf_start_time']
			end_date   = get_conf['conf_end_time']
			conf_name  = get_conf['conf_name']
			confe_date = []
			now = datetime.now()
			current_date = now.strftime('%Y-%m-%d')
			for dt in rrule(DAILY, dtstart=start_date, until=end_date):
				confe_date.append(dt.strftime("%Y-%m-%d"))
		
		return render_template('hall_logs/hall_scan_delegate_sessionwise.html',conf_id=conf_id,conf_key=conf_key,confe_date=confe_date)
	else :
		return "Session Expired"

@app.route('/<int:conf_id>/<conf_key>/get_hall_delegate_session_report', methods = ["GET", "POST"])
def BOGetHallDelegateSessionReport(conf_id,conf_key):
	if session.get("bohallsession") :
		conf_date = request.values.get('conf_date') or None
		delegate_no = request.values.get('delegate_no') or None
		if conf_date:
			cr_date      = datetime.strptime(conf_date, '%Y-%m-%d')
			current_date = cr_date.strftime("%d")
			current_date_1 = int(current_date)
		else:
			current_date = None
		report_data = HallLogsModel().usp_get_delegate_session_wise_report(conf_id,conf_key,current_date_1,delegate_no)

		html_data      = render_template('hall_logs/hall_delegate_session_report_table.html',hallData=report_data,conf_id=conf_id,conf_key=conf_key)
		data           = { 'status': 1,'html':html_data}
		json_data      = json.dumps(data,default=str)
		return json_data

	else :
		return "Session Expired"

@app.route('/<int:conf_id>/<conf_key>/hall_scan_overall_hall', methods = ["GET", "POST"])
def BOHallScanOverallHall(conf_id,conf_key):
	if session.get("bohallsession") :
		get_conf  = BadgeModel().GetConf(conf_id,conf_key)
		if get_conf :
			start_date = get_conf['conf_start_time']
			end_date   = get_conf['conf_end_time']
			conf_name  = get_conf['conf_name']
			confe_date = []
			now = datetime.now()
			current_date = now.strftime('%Y-%m-%d')
			for dt in rrule(DAILY, dtstart=start_date, until=end_date):
				confe_date.append(dt.strftime("%Y-%m-%d"))
		
		return render_template('hall_logs/hall_scan_overall_hall.html',conf_id=conf_id,conf_key=conf_key,confe_date=confe_date)
	else :
		return "Session Expired"

@app.route('/<int:conf_id>/<conf_key>/get_hall_overallhall_report', methods = ["GET", "POST"])
def BOGetHallOverallHallReport(conf_id,conf_key):
	if session.get("bohallsession") :
		conf_date = request.values.get('conf_date') or None
		if conf_date:
			cr_date      = datetime.strptime(conf_date, '%Y-%m-%d')
			current_date = cr_date.strftime("%d")
			current_date_1 = int(current_date)
		else:
			current_date_1 = None
		print(conf_date)
		report_data = HallLogsModel().usp_get_overall_hall_report(conf_id,conf_key,current_date_1,conf_date)

		html_data      = render_template('hall_logs/hall_overall_hall_report_table.html',hallData=report_data,conf_id=conf_id,conf_key=conf_key)
		data           = { 'status': 1,'html':html_data}
		json_data      = json.dumps(data,default=str)
		return json_data

	else :
		return "Session Expired"

@app.route('/<int:conf_id>/<conf_key>/bo_hall_logout', methods = ["GET", "POST"])
def BOHallLogout(conf_id,conf_key):
	if session.get("bohallsession") :
		session.pop('bohallsession', None)
	else :
		pass
	return redirect(url_for('bohalllogs.HallBOLogin' ,conf_id = conf_id,conf_key= conf_key))
		