from flask import Flask, request, Blueprint, jsonify, redirect, url_for,flash, render_template,session,json
import datetime
from datetime import timedelta,date,datetime
from flask import session, app
from .. import Cryptography,Auth,RouteGroup,Helper
from core.model.BadgeModel import BadgeModel
from core.library.email import EMAIL
import base64

app = Blueprint('digitalbatch', __name__)


@app.route('/<int:conf_id>/<conf_key>/digital_badge/del_no/<basecode>', methods = ["GET", "POST"])
def DigitalBadgeLoginBaseCode(conf_id,conf_key,basecode):
	try:
		if basecode:
			base64_bytes   	= basecode.encode("ascii") 
			sample_bytes   	= base64.b64decode(base64_bytes) 
			del_no_str 	   	= sample_bytes.decode("ascii")
			del_no     		= int(del_no_str)
			print()

			conf_data  = BadgeModel().GetConf(conf_id,conf_key)
			if conf_data :
				del_table_name = conf_data["del_table_name"]
			else :
				return "<h2 style='color:red;text-align:center;'>Invalid Url</h2>"
			
			delegates = BadgeModel().get_delegate_by_del_no(del_table_name,del_no,conf_id)
			if delegates:
				# Acc_Delegate_img    = "/static/images/ksos23_digital_badge/acc_delegate.jpg"
				# Crew_img            = "/static/images/ksos23_digital_badge/crew.jpg"
				# Delegate_img        = "/static/images/ksos23_digital_badge/delegate.jpg"
				# Faculty_img         = "/static/images/ksos23_digital_badge/faculty.jpg"
				# Org_Comm_img        = "/static/images/ksos23_digital_badge/organising_committee.jpg"
				# Past_President_img  = "/static/images/ksos23_digital_badge/past_president.jpg"
				# PG_Fellow_img       = "/static/images/ksos23_digital_badge/pg.jpg"
				# Trade_img           = "/static/images/ksos23_digital_badge/trade.jpg"
				# Volunteer_img       = "/static/images/ksos23_digital_badge/volunteer.jpg"
				# Office_Bearer_img   = "/static/images/ksos23_digital_badge/office_bearer.jpg"
				# Reception_Committee_img = "/static/images/ksos23_digital_badge/reception_committee.jpg"

				# AccDelegate = ['Associate Delegate']
				# Delegate = ['Delegate']
				# Faculty = ['Faculty']
				# OfficeBearer = ['Treasurer - KSOS','Member - Exec. Committee','President Elect - KSOS','Member - Sci Comm','Vice President - KSOS','Joint Secretary KSOS','Editor - Website - KSOS','Editor - KJO','President - KSOS','Chairman - Sci. Comm','Secretary - KSOS']
				# PastPresident = ['Past President']
				# PGFellow = ['PG/Fellow']
				# ReceptionCommittee = ['Reception committee']
				# OrgTeam = ['Vice Chair person LOC','Convenor KSOS Golden Jubilee Celebrations','Chairman - Org. Comm','LOC Coordinator','Treasurer - Org. Comm','Organizing Secretary','Vice Chairperson - Org. Comm','Chief Organizing Secretary']

				# role_list = ['Reception committee', 'Trade','Delegate','Volunteer' ,'Associate Delegate','Crew' , 'PG/Fellow','Past President','Faculty']
				role_list = []
				for value in delegates:	
					role = value['role']
					if conf_id == 56 and role in ["DELEGATE" , "ACCOM.DELEGATE","PG"]:  # For multiple role 
						bg_url_front = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/selsicon24/del_acc_del_pg_selsicon24_v1.jpg"
						value["bg_url_front"] = bg_url_front
	
						# value["color_code"]   = [0xfc, 0xe7, 0xce]
						value["color_code"]   = [0xff, 0xff, 0xff]
						bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/selsicon24/del_acc_pg_back_selsi24_v1.jpg"
					
					elif conf_id == 56 and role in ["FACULTY" , "ORG.CHAIRMAN","ORG.COMMITTEE","ORG.SECRETARY","ORG.JOINT SECRETARY"]:  # For multiple role
						bg_url_front = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/selsicon24/org_comm_faculty_selsi24_v1.jpg"
						value["bg_url_front"] = bg_url_front
						# value["color_code"]   = [0xf0, 0xe1, 0xed]
						value["color_code"]   = [0xff, 0xff, 0xff]
						bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/selsicon24/org_com_faculty_back_selsicon24_v1.jpg"
					
					elif conf_id == 56  and   "TRADE" in role: 
						bg_url_front = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/selsicon24/trade_selsi24_v1.jpg"
						value["bg_url_front"] = bg_url_front
						# value["color_code"]   = [0xf0, 0xe1, 0xed]
						value["color_code"]   = [0xff, 0xff, 0xff]
						bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/selsicon24/trade_selsi24_v1.jpg"
					
					# elif conf_id == 56 and role in ["VOLUNTEER" ,"EVENT CO ORDINATOR"]:  # For multiple role
					# 	bg_url_front = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/selsicon24/others_selsi24_v1.jpg"
					# 	value["bg_url_front"] = bg_url_front
					# 	# value["color_code"]   = [0xf0, 0xe1, 0xed]
					# 	value["color_code"]   = [0xff, 0xff, 0xff]
					# 	bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/selsicon24/trade_selsi24_v1.jpg"					
	
					else :
						# return "Else block " + role
						bg_url_front = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/selsicon24/others_selsi24_v1.jpg"
						value["bg_url_front"] = bg_url_front
						# value["color_code"]   = [0xe6, 0xdf, 0xed]
						value["color_code"]   = [0xff , 0xff , 0xff]
						bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/selsicon24/others_selsi24_v1.jpg"
				# 	if conf_id == 10  and   "AWARDEE" in role : 
				# 		bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/awardees_vrsi23_front_3.jpg")
				# 		value["bg_url_front"] = bg_url_front
				# 		value["color_code"]   = [0xff , 0xff , 0xff]
				# 		value["font_color"]   = "black"
				# 		# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/awardees_vrsi23_back.jpg"

				# 	elif conf_id == 10  and     role in ["SUPPORT - IT", "CREW"] : 
				# 		bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/crew_vrsi23_front_4.jpg")
				# 		value["bg_url_front"] = bg_url_front
				# 		value["color_code"]   = [0xff , 0xff , 0xff]
				# 		value["font_color"]   = "black"
				# 		# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/crew_vrsi23_front_4.jpg"

				# 	elif conf_id == 10  and     role in ["INTERNATIONAL FACULTY", "FACULTY"] : 
				# 		bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/faculty_vrsi23_front.jpg")
				# 		value["bg_url_front"] = bg_url_front
				# 		value["color_code"]   = [0xff , 0xff , 0xff]
				# 		value["font_color"]   = "white"
				# 		# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/faculty_vrsi23_back.jpg"

				# 	elif conf_id == 10  and    role in ["ORGANIZING CHAIRMAN" , "LOC","ORGANIZING SECRETARY","ORGANIZING TREASURER","ORGANIZING VICE CHAIRPERSON"] : 
				# 		bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/loc_vrsi23_front.jpg")
				# 		value["bg_url_front"] = bg_url_front
				# 		value["color_code"]   = [0xff , 0xff , 0xff]
				# 		value["font_color"]   = "white"
				# 		# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/loc_vrsi23_back.jpg"

				# 	# elif conf_id == 10  and   "OFFICE BEARERS" in role : 
				# 	elif conf_id == 10  and    role in  ["OFFICE BEARER" , "PAST PRESIDENT","JOINT SECRETARY","TREASURER" , "JOINT TREASURER","EX-OFFICIO","MEMBER, EXECUTIVE COMMITTEE","SECRETARY","VICE PRESIDENT","PRESIDENT","CONVENOR SCIENTIFIC COMMITTEE" ] :     
				# 		bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/office_bearers_vrsi23_front_3.jpg")
				# 		value["bg_url_front"] = bg_url_front
				# 		value["color_code"]   = [0xff , 0xff , 0xff]
				# 		value["font_color"]   = "black"
				# 		# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/office_bearers_vrsi23_back.jpg"

				# 	elif conf_id == 10  and   "TRADE" in role : 
				# 		bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/trade_vrsi23_front.jpg")
				# 		value["bg_url_front"] = bg_url_front
				# 		value["color_code"]   = [0xff , 0xff , 0xff]
				# 		value["font_color"]   = "white"
				# 		# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/trade_vrsi23_front.jpg"

				# 	elif conf_id == 10  and   "VOLUNTEER" in role : 
				# 		bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/volunteers_vrsi23_front.jpg")
				# 		value["bg_url_front"] = bg_url_front
				# 		value["color_code"]   = [0xff , 0xff , 0xff]
				# 		value["font_color"]   = "white"
				# 		# value["font_color"]   = "black"
				# 		# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/volunteers_vrsi23_front.jpg"
						
				# 	elif conf_id == 10  and    role  in ["DEELGATE" , "ACC.DELEGATE" , "TRAINEE"]: 
				# 		bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/delegate_vrsi23_front.jpg")
				# 		value["bg_url_front"] = bg_url_front
				# 		value["color_code"]   = [0xff , 0xff , 0xff]
				# 		value["font_color"]   = "white"
				# 		# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/volunteers_vrsi23_back.jpg"		
				# 	else:
				# 		bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/delegate_vrsi23_front.jpg")
				# 		value["bg_url_front"] = bg_url_front
				# 		value["color_code"]   = [0xff , 0xff , 0xff]
				# 		value["font_color"]   = "white"
				# 		# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/delegate_vrsi23_back.jpg"
						
				return render_template('digital_batch/dashboard.html',conf_data=conf_data,conf_id=conf_id,conf_key=conf_key,delegates=delegates,is_auto_login=1,role_list=role_list)	
			else :	
				return "<h2 style='color:red;text-align:center;'>No Badge Found</h2>"
		else:
			return "<h2 style='color:red;text-align:center;'>Invalid Url</h2>"
	except Exception as e:
		raise e



@app.route('/<int:conf_id>/<conf_key>/digital_badge/at/', methods = ["GET", "POST"])
@app.route('/<int:conf_id>/<conf_key>/digital_badge/at/<uuid>', methods = ["GET", "POST"])
def DigitalBadgeAutoLogin(conf_id,conf_key,uuid=None):
	try:
		if uuid:
			conf_data  = BadgeModel().GetConf(conf_id,conf_key)
			if conf_data :
				del_table_name = conf_data["conf_schema"] +".delegates"
			else :
				return "<h4 style='color:red;'> Invalid URL </h4>"

			delegates = BadgeModel().get_uuid_delegates_table(del_table_name,uuid,conf_id)
			fonts_data      =  BadgeModel().get_font_family_data()
			print("delegates ------ ",delegates)
			if delegates:
				badge_temp_data = BadgeModel().get_badge_temp_data(conf_id,delegates[0]['badge_template_id'])
				if badge_temp_data:
					front_font_id   = badge_temp_data["front_font_id"] or None
					back_font_id    = badge_temp_data["back_font_id"] or None
					
				if front_font_id:
					front_font =  next((font for font in fonts_data if font['font_id'] == int(front_font_id)), None)
					
				if back_font_id:
					back_font =  next((font for font in fonts_data if font['font_id'] == int(back_font_id)), None)
				
				fonts_data      = [font for font in fonts_data if font['font_id'] in [front_font_id,back_font_id]]
				
				privew_html =  getBadgePreview(conf_id,conf_key,del_table_name,delegates[0])
				return render_template('digital_batch/dashboard.html',conf_data=conf_data,conf_id=conf_id,conf_key=conf_key,delegates=delegates,is_auto_login=1,privew_html=privew_html,fonts_data=fonts_data)	
			else :	
				return "<h2 style='color:red;text-align:center;'>No Badge Found</h2>"
		else:
			return "<h4 style='color:red;'> Invalid URL </h4>"
			# return redirect(url_for('digitalbatch.DigitalBadge',conf_id=conf_id,conf_key=conf_key))	
	except Exception as e:
		raise e



def getBadgePreview(conf_id,conf_key,del_table_name,delegate):
	btemp_id 		= delegate.get('badge_template_id')

	badge_temp_data = BadgeModel().get_badge_temp_data(conf_id,btemp_id)
	role_wise_bg    = BadgeModel().get_role_wise_badge_all(conf_id,btemp_id)
	if role_wise_bg:
		role_data_dict      = {item['role_id']: item.get('bg_url') for item in role_wise_bg}
				

	role 			= None	
	counter 		= None
	batch 			= None
	del_no_from 	= delegate.get('delegate_no')
	del_no_to 		= delegate.get('delegate_no')
	role_ids 		= None		
	badge_limit 	= None
	is_commitment 	= None

	user_data 		= BadgeModel().dataForBadgePrint(conf_id,role,counter,batch,del_no_from,del_no_to,del_table_name,role_ids,badge_limit,is_commitment)
	if user_data:

		preview_html    = ""
		if user_data and len(user_data) > 0:
			for user in user_data:
				
				badge_field_html_set = badge_temp_data["badge_pdf_contant"]
				print(badge_field_html_set)
				user['bg_url']      =  role_data_dict.get(user.get('role_id')) or badge_temp_data.get('b_background_img', '')
				if user['bg_url']:
					user['bg_url'] = Helper.get_url_base64(user['bg_url'])
				
				preview_html =  Helper.convert_html_for_badge_screen(badge_field_html_set, user)
			

		return preview_html;			



@app.route('/<int:conf_id>/<conf_key>/digital_badge_test/at/', methods = ["GET", "POST"])
@app.route('/<int:conf_id>/<conf_key>/digital_badge_test/at/<uuid>', methods = ["GET", "POST"])
def DigitalBadgeAutoLoginTest(conf_id,conf_key,uuid=None):
	try:
		if uuid:
			conf_data  = BadgeModel().GetConf(conf_id,conf_key)
			if conf_data :
				del_table_name = conf_data["del_table_name"]
			else :
				return "<h4 style='color:red;'> Invalid URL </h4>"
			
			delegates = BadgeModel().get_uuid_delegates_table(del_table_name,uuid,conf_id)
			if delegates:
				# Acc_Delegate_img    = "/static/images/ksos23_digital_badge/acc_delegate.jpg"
				# Crew_img            = "/static/images/ksos23_digital_badge/crew.jpg"
				# Delegate_img        = "/static/images/ksos23_digital_badge/delegate.jpg"
				# Faculty_img         = "/static/images/ksos23_digital_badge/faculty.jpg"
				# Org_Comm_img        = "/static/images/ksos23_digital_badge/organising_committee.jpg"
				# Past_President_img  = "/static/images/ksos23_digital_badge/past_president.jpg"
				# PG_Fellow_img       = "/static/images/ksos23_digital_badge/pg.jpg"
				# Trade_img           = "/static/images/ksos23_digital_badge/trade.jpg"
				# Volunteer_img       = "/static/images/ksos23_digital_badge/volunteer.jpg"
				# Office_Bearer_img   = "/static/images/ksos23_digital_badge/office_bearer.jpg"
				# Reception_Committee_img = "/static/images/ksos23_digital_badge/reception_committee.jpg"

				# AccDelegate = ['Associate Delegate']
				# Delegate = ['Delegate']
				# Faculty = ['Faculty']
				# OfficeBearer = ['Treasurer - KSOS','Member - Exec. Committee','President Elect - KSOS','Member - Sci Comm','Vice President - KSOS','Joint Secretary KSOS','Editor - Website - KSOS','Editor - KJO','President - KSOS','Chairman - Sci. Comm','Secretary - KSOS']
				# PastPresident = ['Past President']
				# PGFellow = ['PG/Fellow']
				# ReceptionCommittee = ['Reception committee']
				# OrgTeam = ['Vice Chair person LOC','Convenor KSOS Golden Jubilee Celebrations','Chairman - Org. Comm','LOC Coordinator','Treasurer - Org. Comm','Organizing Secretary','Vice Chairperson - Org. Comm','Chief Organizing Secretary']

				# role_list = ['Reception committee', 'Trade','Delegate','Volunteer' ,'Associate Delegate','Crew' , 'PG/Fellow','Past President','Faculty']

				role_list = []
				for value in delegates:	
					role = value['role']
					if conf_id == 10  and   "AWARDEE" in role : 
						bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/awardees_vrsi23_front_3.jpg")
						value["bg_url_front"] = bg_url_front
						value["color_code"]   = [0xff , 0xff , 0xff]
						value["font_color"]   = "black"
						# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/awardees_vrsi23_back.jpg"

					elif conf_id == 10  and     role in ["SUPPORT - IT", "CREW"] : 
						bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/crew_vrsi23_front_4.jpg")
						value["bg_url_front"] = bg_url_front
						value["color_code"]   = [0xff , 0xff , 0xff]
						value["font_color"]   = "black"
						# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/crew_vrsi23_front_4.jpg"

					elif conf_id == 10  and     role in ["INTERNATIONAL FACULTY", "FACULTY"] : 
						bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/faculty_vrsi23_front.jpg")
						value["bg_url_front"] = bg_url_front
						value["color_code"]   = [0xff , 0xff , 0xff]
						value["font_color"]   = "white"
						# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/faculty_vrsi23_back.jpg"

					elif conf_id == 10  and    role in ["ORGANIZING CHAIRMAN" , "LOC","ORGANIZING SECRETARY","ORGANIZING TREASURER","ORGANIZING VICE CHAIRPERSON"] : 
						bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/loc_vrsi23_front.jpg")
						value["bg_url_front"] = bg_url_front
						value["color_code"]   = [0xff , 0xff , 0xff]
						value["font_color"]   = "white"
						# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/loc_vrsi23_back.jpg"

					# elif conf_id == 10  and   "OFFICE BEARERS" in role : 
					elif conf_id == 10  and    role in  ["OFFICE BEARER" , "PAST PRESIDENT","JOINT SECRETARY","TREASURER" , "JOINT TREASURER","EX-OFFICIO","MEMBER, EXECUTIVE COMMITTEE","SECRETARY","VICE PRESIDENT","PRESIDENT","CONVENOR SCIENTIFIC COMMITTEE" ] :     
						bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/office_bearers_vrsi23_front_3.jpg")
						value["bg_url_front"] = bg_url_front
						value["color_code"]   = [0xff , 0xff , 0xff]
						value["font_color"]   = "black"
						# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/office_bearers_vrsi23_back.jpg"

					elif conf_id == 10  and   "TRADE" in role : 
						bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/trade_vrsi23_front.jpg")
						value["bg_url_front"] = bg_url_front
						value["color_code"]   = [0xff , 0xff , 0xff]
						value["font_color"]   = "white"
						# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/trade_vrsi23_front.jpg"

					elif conf_id == 10  and   "VOLUNTEER" in role : 
						bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/volunteers_vrsi23_front.jpg")
						value["bg_url_front"] = bg_url_front
						value["color_code"]   = [0xff , 0xff , 0xff]
						value["font_color"]   = "white"
						# value["font_color"]   = "black"
						# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/volunteers_vrsi23_front.jpg"
						
					elif conf_id == 10  and    role  in ["DEELGATE" , "ACC.DELEGATE" , "TRAINEE"]: 
						bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/delegate_vrsi23_front.jpg")
						value["bg_url_front"] = bg_url_front
						value["color_code"]   = [0xff , 0xff , 0xff]
						value["font_color"]   = "white"
						# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/volunteers_vrsi23_back.jpg"		
					else:
						bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/delegate_vrsi23_front.jpg")
						value["bg_url_front"] = bg_url_front
						value["color_code"]   = [0xff , 0xff , 0xff]
						value["font_color"]   = "white"
						# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/delegate_vrsi23_back.jpg"
						
				return render_template('digital_batch/dashboard-test.html',conf_data=conf_data,conf_id=conf_id,conf_key=conf_key,delegates=delegates,is_auto_login=1,role_list=role_list)	
			else :	
				return "<h2 style='color:red;text-align:center;'>No Badge Found</h2>"
		else:
			return redirect(url_for('digitalbatch.DigitalBadge',conf_id=conf_id,conf_key=conf_key))	
	except Exception as e:
		raise e

# Non OTP
@app.route('/<int:conf_id>/<conf_key>/digital_badge_non_otp', methods = ["GET", "POST"])
def DigitalBadgeNonOTP(conf_id,conf_key):
	try:
		conf_data  = BadgeModel().GetConf(conf_id,conf_key)
		if conf_data :
			del_table_name = conf_data["del_table_name"]
		else :
			return "<h4 style='color:red;'> Invalid URL </h4>"
		
		if session.get('digitalbatchsession'):
			delegates =  session.get('digitalbatchsession')
			if delegates:
				# Acc_Delegate_img    = "/static/images/ksos23_digital_badge/acc_delegate.jpg"
				# Crew_img            = "/static/images/ksos23_digital_badge/crew.jpg"
				# Delegate_img        = "/static/images/ksos23_digital_badge/delegate.jpg"
				# Faculty_img         = "/static/images/ksos23_digital_badge/faculty.jpg"
				# Org_Comm_img        = "/static/images/ksos23_digital_badge/organising_committee.jpg"
				# Past_President_img  = "/static/images/ksos23_digital_badge/past_president.jpg"
				# PG_Fellow_img       = "/static/images/ksos23_digital_badge/pg.jpg"
				# Trade_img           = "/static/images/ksos23_digital_badge/trade.jpg"
				# Volunteer_img       = "/static/images/ksos23_digital_badge/volunteer.jpg"
				# Office_Bearer_img   = "/static/images/ksos23_digital_badge/office_bearer.jpg"
				# Reception_Committee_img = "/static/images/ksos23_digital_badge/reception_committee.jpg"

				# AccDelegate = ['Associate Delegate']
				# Delegate = ['Delegate']
				# Faculty = ['Faculty']
				# OfficeBearer = ['Treasurer - KSOS','Member - Exec. Committee','President Elect - KSOS','Member - Sci Comm','Vice President - KSOS','Joint Secretary KSOS','Editor - Website - KSOS','Editor - KJO','President - KSOS','Chairman - Sci. Comm','Secretary - KSOS']
				# PastPresident = ['Past President']
				# PGFellow = ['PG/Fellow']
				# ReceptionCommittee = ['Reception committee']
				# OrgTeam = ['Vice Chair person LOC','Convenor KSOS Golden Jubilee Celebrations','Chairman - Org. Comm','LOC Coordinator','Treasurer - Org. Comm','Organizing Secretary','Vice Chairperson - Org. Comm','Chief Organizing Secretary']

				# role_list = ['Reception committee', 'Trade','Delegate','Volunteer' ,'Associate Delegate','Crew' , 'PG/Fellow','Past President','Faculty']

				role_list = []
				for value in delegates:	
					role = value['role']
					if conf_id == 10  and   "AWARDEE" in role : 
						bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/awardees_vrsi23_front_3.jpg")
						value["bg_url_front"] = bg_url_front
						value["color_code"]   = [0xff , 0xff , 0xff]
						value["font_color"]   = "black"
						# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/awardees_vrsi23_back.jpg"

					elif conf_id == 10  and     role in ["SUPPORT - IT", "CREW"] : 
						bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/crew_vrsi23_front_4.jpg")
						value["bg_url_front"] = bg_url_front
						value["color_code"]   = [0xff , 0xff , 0xff]
						value["font_color"]   = "black"
						# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/crew_vrsi23_front_4.jpg"

					elif conf_id == 10  and     role in ["INTERNATIONAL FACULTY", "FACULTY"] : 
						bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/faculty_vrsi23_front.jpg")
						value["bg_url_front"] = bg_url_front
						value["color_code"]   = [0xff , 0xff , 0xff]
						value["font_color"]   = "white"
						# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/faculty_vrsi23_back.jpg"

					elif conf_id == 10  and    role in ["ORGANIZING CHAIRMAN" , "LOC","ORGANIZING SECRETARY","ORGANIZING TREASURER","ORGANIZING VICE CHAIRPERSON"] : 
						bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/loc_vrsi23_front.jpg")
						value["bg_url_front"] = bg_url_front
						value["color_code"]   = [0xff , 0xff , 0xff]
						value["font_color"]   = "white"
						# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/loc_vrsi23_back.jpg"

					# elif conf_id == 10  and   "OFFICE BEARERS" in role : 
					elif conf_id == 10  and    role in  ["OFFICE BEARER" , "PAST PRESIDENT","JOINT SECRETARY","TREASURER" , "JOINT TREASURER","EX-OFFICIO","MEMBER, EXECUTIVE COMMITTEE","SECRETARY","VICE PRESIDENT","PRESIDENT","CONVENOR SCIENTIFIC COMMITTEE" ] :     
						bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/office_bearers_vrsi23_front_3.jpg")
						value["bg_url_front"] = bg_url_front
						value["color_code"]   = [0xff , 0xff , 0xff]
						value["font_color"]   = "black"
						# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/office_bearers_vrsi23_back.jpg"

					elif conf_id == 10  and   "TRADE" in role : 
						bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/trade_vrsi23_front.jpg")
						value["bg_url_front"] = bg_url_front
						value["color_code"]   = [0xff , 0xff , 0xff]
						value["font_color"]   = "white"
						# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/trade_vrsi23_front.jpg"

					elif conf_id == 10  and   "VOLUNTEER" in role : 
						bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/volunteers_vrsi23_front.jpg")
						value["bg_url_front"] = bg_url_front
						value["color_code"]   = [0xff , 0xff , 0xff]
						value["font_color"]   = "white"
						# value["font_color"]   = "black"
						# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/volunteers_vrsi23_front.jpg"
						
					elif conf_id == 10  and    role  in ["DEELGATE" , "ACC.DELEGATE" , "TRAINEE"]: 
						bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/delegate_vrsi23_front.jpg")
						value["bg_url_front"] = bg_url_front
						value["color_code"]   = [0xff , 0xff , 0xff]
						value["font_color"]   = "white"
						# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/volunteers_vrsi23_back.jpg"		
					else:
						bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/delegate_vrsi23_front.jpg")
						value["bg_url_front"] = bg_url_front
						value["color_code"]   = [0xff , 0xff , 0xff]
						value["font_color"]   = "white"
						# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/delegate_vrsi23_back.jpg"
						
						
			return render_template('digital_batch/dashboard.html',conf_data=conf_data,conf_id=conf_id,conf_key=conf_key,delegates=delegates,isnonOTP = 1,role_list=role_list)
		else:
			return render_template('digital_batch/login_non_otp.html',conf_data=conf_data,conf_id=conf_id,conf_key=conf_key)
	except Exception as e:
		raise e

@app.route('/<int:conf_id>/<conf_key>/post_login_non_otp', methods = ["GET", "POST"])
def postLoginNonOTP(conf_id,conf_key):
	try:
		get_conf  = BadgeModel().GetConf(conf_id,conf_key)
		if get_conf :
			del_table_name = get_conf["del_table_name"]
		else :
			return "<h4 style='color:red;'> Invalid URL </h4>"

		email_mobile    = request.values.get('email_mobile')
		userData_list   = BadgeModel().check_email_mobile(del_table_name,email_mobile,conf_id)
		if userData_list:
				session['digitalbatchsession'] =  userData_list
				return redirect(url_for('digitalbatch.DigitalBadgeNonOTP',conf_id=conf_id,conf_key=conf_key))
		else:
			flash("Email id is not registered","errorMsg")
			return redirect(url_for('digitalbatch.DigitalBadgeNonOTP',conf_id=conf_id,conf_key=conf_key))	

	except Exception as e:
		raise e

# End Non OTP






@app.route('/<int:conf_id>/<conf_key>/db_logout', methods = ["GET", "POST"])
def dbLogout(conf_id,conf_key):
	isnonOTP = request.values.get('isnonOTP',None)
	if session.get("digitalbatchsession") :
		session.pop('digitalbatchsession', None)
	else :
		pass
	if isnonOTP:
		return redirect(url_for('digitalbatch.DigitalBadgeNonOTP' ,conf_id = conf_id,conf_key= conf_key))
		
	return redirect(url_for('digitalbatch.DigitalBadge' ,conf_id = conf_id,conf_key= conf_key))


# With OTP

@app.route('/<int:conf_id>/<conf_key>/digital_badge_', methods = ["GET", "POST"])
def DigitalBadge(conf_id,conf_key):
	try:
		conf_data  = BadgeModel().GetConf(conf_id,conf_key)
		if session.get('digitalbatchsession') :
			del_table_name = conf_data["del_table_name"]
			delegates =  session.get('digitalbatchsession')
			if delegates:
				# Acc_Delegate_img    = "/static/images/ksos23_digital_badge/acc_delegate.jpg"
				# Crew_img            = "/static/images/ksos23_digital_badge/crew.jpg"
				# Delegate_img        = "/static/images/ksos23_digital_badge/delegate.jpg"
				# Faculty_img         = "/static/images/ksos23_digital_badge/faculty.jpg"
				# Org_Comm_img        = "/static/images/ksos23_digital_badge/organising_committee.jpg"
				# Past_President_img  = "/static/images/ksos23_digital_badge/past_president.jpg"
				# PG_Fellow_img       = "/static/images/ksos23_digital_badge/pg.jpg"
				# Trade_img           = "/static/images/ksos23_digital_badge/trade.jpg"
				# Volunteer_img       = "/static/images/ksos23_digital_badge/volunteer.jpg"
				# Office_Bearer_img   = "/static/images/ksos23_digital_badge/office_bearer.jpg"
				# Reception_Committee_img = "/static/images/ksos23_digital_badge/reception_committee.jpg"

				# AccDelegate = ['Associate Delegate']
				# Delegate = ['Delegate']
				# Faculty = ['Faculty']
				# OfficeBearer = ['Treasurer - KSOS','Member - Exec. Committee','President Elect - KSOS','Member - Sci Comm','Vice President - KSOS','Joint Secretary KSOS','Editor - Website - KSOS','Editor - KJO','President - KSOS','Chairman - Sci. Comm','Secretary - KSOS']
				# PastPresident = ['Past President']
				# PGFellow = ['PG/Fellow']
				# ReceptionCommittee = ['Reception committee']
				# OrgTeam = ['Vice Chair person LOC','Convenor KSOS Golden Jubilee Celebrations','Chairman - Org. Comm','LOC Coordinator','Treasurer - Org. Comm','Organizing Secretary','Vice Chairperson - Org. Comm','Chief Organizing Secretary']

				# role_list = ['Reception committee', 'Trade','Delegate','Volunteer' ,'Associate Delegate','Crew' , 'PG/Fellow','Past President','Faculty']

				role_list = []
				for value in delegates:	
					role = value['role']
					if conf_id == 56 and role in ["DELEGATE" , "ACCOM.DELEGATE","PG"]:  # For multiple role 
						bg_url_front = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/selsicon24/del_acc_del_pg_selsicon24_v1.jpg"
						value["bg_url_front"] = bg_url_front
	
						# value["color_code"]   = [0xfc, 0xe7, 0xce]
						value["color_code"]   = [0xff, 0xff, 0xff]
						bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/selsicon24/del_acc_pg_back_selsi24_v1.jpg"
					
					elif conf_id == 56 and role in ["FACULTY" , "ORG.CHAIRMAN","ORG.COMMITTEE","ORG.SECRETARY","ORG.JOINT SECRETARY"]:  # For multiple role
						bg_url_front = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/selsicon24/org_comm_faculty_selsi24_v1.jpg"
						value["bg_url_front"] = bg_url_front
						# value["color_code"]   = [0xf0, 0xe1, 0xed]
						value["color_code"]   = [0xff, 0xff, 0xff]
						bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/selsicon24/org_com_faculty_back_selsicon24_v1.jpg"
					
					elif conf_id == 56  and   "TRADE" in role: 
						bg_url_front = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/selsicon24/trade_selsi24_v1.jpg"
						value["bg_url_front"] = bg_url_front
						# value["color_code"]   = [0xf0, 0xe1, 0xed]
						value["color_code"]   = [0xff, 0xff, 0xff]
						bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/selsicon24/trade_selsi24_v1.jpg"
					
					# elif conf_id == 56 and role in ["VOLUNTEER" ,"EVENT CO ORDINATOR"]:  # For multiple role
					# 	bg_url_front = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/selsicon24/others_selsi24_v1.jpg"
					# 	value["bg_url_front"] = bg_url_front
					# 	# value["color_code"]   = [0xf0, 0xe1, 0xed]
					# 	value["color_code"]   = [0xff, 0xff, 0xff]
					# 	bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/selsicon24/trade_selsi24_v1.jpg"					
	
					else :
						# return "Else block " + role
						bg_url_front = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/selsicon24/others_selsi24_v1.jpg"
						value["bg_url_front"] = bg_url_front
						# value["color_code"]   = [0xe6, 0xdf, 0xed]
						value["color_code"]   = [0xff , 0xff , 0xff]
						bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/selsicon24/others_selsi24_v1.jpg"
				# 	if conf_id == 10  and   "AWARDEE" in role : 
				# 		bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/awardees_vrsi23_front_3.jpg")
				# 		value["bg_url_front"] = bg_url_front
				# 		value["color_code"]   = [0xff , 0xff , 0xff]
				# 		value["font_color"]   = "black"
				# 		# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/awardees_vrsi23_back.jpg"

				# 	elif conf_id == 10  and     role in ["SUPPORT - IT", "CREW"] : 
				# 		bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/crew_vrsi23_front_4.jpg")
				# 		value["bg_url_front"] = bg_url_front
				# 		value["color_code"]   = [0xff , 0xff , 0xff]
				# 		value["font_color"]   = "black"
				# 		# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/crew_vrsi23_front_4.jpg"

				# 	elif conf_id == 10  and     role in ["INTERNATIONAL FACULTY", "FACULTY"] : 
				# 		bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/faculty_vrsi23_front.jpg")
				# 		value["bg_url_front"] = bg_url_front
				# 		value["color_code"]   = [0xff , 0xff , 0xff]
				# 		value["font_color"]   = "white"
				# 		# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/faculty_vrsi23_back.jpg"

				# 	elif conf_id == 10  and    role in ["ORGANIZING CHAIRMAN" , "LOC","ORGANIZING SECRETARY","ORGANIZING TREASURER","ORGANIZING VICE CHAIRPERSON"] : 
				# 		bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/loc_vrsi23_front.jpg")
				# 		value["bg_url_front"] = bg_url_front
				# 		value["color_code"]   = [0xff , 0xff , 0xff]
				# 		value["font_color"]   = "white"
				# 		# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/loc_vrsi23_back.jpg"

				# 	# elif conf_id == 10  and   "OFFICE BEARERS" in role : 
				# 	elif conf_id == 10  and    role in  ["OFFICE BEARER" , "PAST PRESIDENT","JOINT SECRETARY","TREASURER" , "JOINT TREASURER","EX-OFFICIO","MEMBER, EXECUTIVE COMMITTEE","SECRETARY","VICE PRESIDENT","PRESIDENT","CONVENOR SCIENTIFIC COMMITTEE" ] :     
				# 		bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/office_bearers_vrsi23_front_3.jpg")
				# 		value["bg_url_front"] = bg_url_front
				# 		value["color_code"]   = [0xff , 0xff , 0xff]
				# 		value["font_color"]   = "black"
				# 		# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/office_bearers_vrsi23_back.jpg"

				# 	elif conf_id == 10  and   "TRADE" in role : 
				# 		bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/trade_vrsi23_front.jpg")
				# 		value["bg_url_front"] = bg_url_front
				# 		value["color_code"]   = [0xff , 0xff , 0xff]
				# 		value["font_color"]   = "white"
				# 		# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/trade_vrsi23_front.jpg"

				# 	elif conf_id == 10  and   "VOLUNTEER" in role : 
				# 		bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/volunteers_vrsi23_front.jpg")
				# 		value["bg_url_front"] = bg_url_front
				# 		value["color_code"]   = [0xff , 0xff , 0xff]
				# 		value["font_color"]   = "white"
				# 		# value["font_color"]   = "black"
				# 		# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/volunteers_vrsi23_front.jpg"
						
				# 	elif conf_id == 10  and    role  in ["DEELGATE" , "ACC.DELEGATE" , "TRAINEE"]: 
				# 		bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/delegate_vrsi23_front.jpg")
				# 		value["bg_url_front"] = bg_url_front
				# 		value["color_code"]   = [0xff , 0xff , 0xff]
				# 		value["font_color"]   = "white"
				# 		# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/volunteers_vrsi23_back.jpg"		
				# 	else:
				# 		bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/delegate_vrsi23_front.jpg")
				# 		value["bg_url_front"] = bg_url_front
				# 		value["color_code"]   = [0xff , 0xff , 0xff]
				# 		value["font_color"]   = "white"
				# 		# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/delegate_vrsi23_back.jpg"
						
			return render_template('digital_batch/dashboard.html',conf_data=conf_data,conf_id=conf_id,conf_key=conf_key,delegates=delegates,role_list=role_list)
		else:
			return render_template('digital_batch/login.html',conf_data=conf_data,conf_id=conf_id,conf_key=conf_key)
	except Exception as e:
		raise e

@app.route('/<int:conf_id>/<conf_key>/digital_badge_test', methods = ["GET", "POST"])
def DigitalBadgeTest(conf_id,conf_key):
	try:
		conf_data  = BadgeModel().GetConf(conf_id,conf_key)
		if session.get('digitalbatchsession') :
			del_table_name = conf_data["del_table_name"]
			delegates =  session.get('digitalbatchsession')
			if delegates:
				# Acc_Delegate_img    = "/static/images/ksos23_digital_badge/acc_delegate.jpg"
				# Crew_img            = "/static/images/ksos23_digital_badge/crew.jpg"
				# Delegate_img        = "/static/images/ksos23_digital_badge/delegate.jpg"
				# Faculty_img         = "/static/images/ksos23_digital_badge/faculty.jpg"
				# Org_Comm_img        = "/static/images/ksos23_digital_badge/organising_committee.jpg"
				# Past_President_img  = "/static/images/ksos23_digital_badge/past_president.jpg"
				# PG_Fellow_img       = "/static/images/ksos23_digital_badge/pg.jpg"
				# Trade_img           = "/static/images/ksos23_digital_badge/trade.jpg"
				# Volunteer_img       = "/static/images/ksos23_digital_badge/volunteer.jpg"
				# Office_Bearer_img   = "/static/images/ksos23_digital_badge/office_bearer.jpg"
				# Reception_Committee_img = "/static/images/ksos23_digital_badge/reception_committee.jpg"

				# AccDelegate = ['Associate Delegate']
				# Delegate = ['Delegate']
				# Faculty = ['Faculty']
				# OfficeBearer = ['Treasurer - KSOS','Member - Exec. Committee','President Elect - KSOS','Member - Sci Comm','Vice President - KSOS','Joint Secretary KSOS','Editor - Website - KSOS','Editor - KJO','President - KSOS','Chairman - Sci. Comm','Secretary - KSOS']
				# PastPresident = ['Past President']
				# PGFellow = ['PG/Fellow']
				# ReceptionCommittee = ['Reception committee']
				# OrgTeam = ['Vice Chair person LOC','Convenor KSOS Golden Jubilee Celebrations','Chairman - Org. Comm','LOC Coordinator','Treasurer - Org. Comm','Organizing Secretary','Vice Chairperson - Org. Comm','Chief Organizing Secretary']

				# role_list = ['Reception committee', 'Trade','Delegate','Volunteer' ,'Associate Delegate','Crew' , 'PG/Fellow','Past President','Faculty']

				role_list = []
				for value in delegates:	
					role = value['role']
					if conf_id == 10  and   "AWARDEE" in role : 
						bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/awardees_vrsi23_front_3.jpg")
						value["bg_url_front"] = bg_url_front
						value["color_code"]   = [0xff , 0xff , 0xff]
						value["font_color"]   = "black"
						# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/awardees_vrsi23_back.jpg"

					elif conf_id == 10  and     role in ["SUPPORT - IT", "CREW"] : 
						bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/crew_vrsi23_front_4.jpg")
						value["bg_url_front"] = bg_url_front
						value["color_code"]   = [0xff , 0xff , 0xff]
						value["font_color"]   = "black"
						# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/crew_vrsi23_front_4.jpg"

					elif conf_id == 10  and     role in ["INTERNATIONAL FACULTY", "FACULTY"] : 
						bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/faculty_vrsi23_front.jpg")
						value["bg_url_front"] = bg_url_front
						value["color_code"]   = [0xff , 0xff , 0xff]
						value["font_color"]   = "white"
						# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/faculty_vrsi23_back.jpg"

					elif conf_id == 10  and    role in ["ORGANIZING CHAIRMAN" , "LOC","ORGANIZING SECRETARY","ORGANIZING TREASURER","ORGANIZING VICE CHAIRPERSON"] : 
						bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/loc_vrsi23_front.jpg")
						value["bg_url_front"] = bg_url_front
						value["color_code"]   = [0xff , 0xff , 0xff]
						value["font_color"]   = "white"
						# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/loc_vrsi23_back.jpg"

					# elif conf_id == 10  and   "OFFICE BEARERS" in role : 
					elif conf_id == 10  and    role in  ["OFFICE BEARER" , "PAST PRESIDENT","JOINT SECRETARY","TREASURER" , "JOINT TREASURER","EX-OFFICIO","MEMBER, EXECUTIVE COMMITTEE","SECRETARY","VICE PRESIDENT","PRESIDENT","CONVENOR SCIENTIFIC COMMITTEE" ] :     
						bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/office_bearers_vrsi23_front_3.jpg")
						value["bg_url_front"] = bg_url_front
						value["color_code"]   = [0xff , 0xff , 0xff]
						value["font_color"]   = "black"
						# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/office_bearers_vrsi23_back.jpg"

					elif conf_id == 10  and   "TRADE" in role : 
						bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/trade_vrsi23_front.jpg")
						value["bg_url_front"] = bg_url_front
						value["color_code"]   = [0xff , 0xff , 0xff]
						value["font_color"]   = "white"
						# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/trade_vrsi23_front.jpg"

					elif conf_id == 10  and   "VOLUNTEER" in role : 
						bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/volunteers_vrsi23_front.jpg")
						value["bg_url_front"] = bg_url_front
						value["color_code"]   = [0xff , 0xff , 0xff]
						value["font_color"]   = "white"
						# value["font_color"]   = "black"
						# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/volunteers_vrsi23_front.jpg"
						
					elif conf_id == 10  and    role  in ["DEELGATE" , "ACC.DELEGATE" , "TRAINEE"]: 
						bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/delegate_vrsi23_front.jpg")
						value["bg_url_front"] = bg_url_front
						value["color_code"]   = [0xff , 0xff , 0xff]
						value["font_color"]   = "white"
						# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/volunteers_vrsi23_back.jpg"		
					else:
						bg_url_front = Helper.get_url_base64("https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/delegate_vrsi23_front.jpg")
						value["bg_url_front"] = bg_url_front
						value["color_code"]   = [0xff , 0xff , 0xff]
						value["font_color"]   = "white"
						# bg_url_commit_image = "https://aws-s3store.s3.ap-southeast-1.amazonaws.com/vrsi23/delegate_vrsi23_back.jpg"
						
						
			return render_template('digital_batch/dashboard-test.html',conf_data=conf_data,conf_id=conf_id,conf_key=conf_key,delegates=delegates,role_list=role_list)
		else:
			return render_template('digital_batch/login.html',conf_data=conf_data,conf_id=conf_id,conf_key=conf_key)
	except Exception as e:
		raise e

	
@app.route('/<int:conf_id>/<conf_key>/post_login', methods = ["GET", "POST"])
def postLogin(conf_id,conf_key):
	try:
		get_conf  = BadgeModel().GetConf(conf_id,conf_key)
		if get_conf :
			del_table_name = get_conf["del_table_name"]
		else :
			return "<h4 style='color:red;'> Invalid URL </h4>"
		
# 		return del_table_name 
		email_mobile    = request.values.get('email_mobile')
		l_otp = request.values.get('l_otp',None)
		userData_list        = BadgeModel().check_email_mobile(del_table_name,email_mobile,conf_id)
		if userData_list:
			if l_otp:
				for userData in userData_list:
					if userData['otp'] == int(l_otp):
						session['digitalbatchsession'] =  userData_list
						return redirect(url_for('digitalbatch.DigitalBadge',conf_id=conf_id,conf_key=conf_key))
				flash("Incorrect OTP, Please try again","errorMsg")
				return redirect(url_for('digitalbatch.DigitalBadge',conf_id=conf_id,conf_key=conf_key))		
			else:		
				userData = userData_list[0]
				delegate_id = userData['delegate_id']
				otp  = userData['otp']
				if otp is None:
					otp = Helper.random4digt()
				updated_at      =  datetime.now()
				BadgeModel().update_delegate_otp(del_table_name,delegate_id,updated_at,otp)
				email = userData['email']
				if email:
					if sendOtpMail(email,otp,conf_id,conf_key):
						return redirect (url_for('digitalbatch.getOtp',conf_id=conf_id,conf_key=conf_key,delegate_id=delegate_id))
					else:
						flash("Something Wrong, Please Try Again","errorMsg")
						return redirect(url_for('digitalbatch.DigitalBadge',conf_id=conf_id,conf_key=conf_key))	
				else:
					flash("Email id not found","errorMsg")
					return redirect(url_for('digitalbatch.DigitalBadge',conf_id=conf_id,conf_key=conf_key))

		else:
			flash("Email id is not registered","errorMsg")
			return redirect(url_for('digitalbatch.DigitalBadge',conf_id=conf_id,conf_key=conf_key))	

	except Exception as e:
		raise e
		
@app.route('/<int:conf_id>/<conf_key>/<int:delegate_id>/resend_otp', methods = ["GET", "POST"])
def resendOTP(conf_id,conf_key,delegate_id):
	try:
		get_conf  = BadgeModel().GetConf(conf_id,conf_key)
		if get_conf :
			del_table_name = get_conf["del_table_name"]
		else :
			return "<h4 style='color:red;'> Invalid URL </h4>"

		userData    = BadgeModel().getDelegateByID(del_table_name,delegate_id)
		if userData:
			otp  = userData['otp']
			if otp is None:
				otp = Helper.random4digt()
			updated_at      =  datetime.now()
			BadgeModel().update_delegate_otp(del_table_name,delegate_id,updated_at,otp)
			email = userData['email']
			if email:
				if sendOtpMail(email,otp,conf_id,conf_key):
					return redirect (url_for('digitalbatch.getOtp',conf_id=conf_id,conf_key=conf_key,delegate_id=delegate_id))
				else:
					flash("Something Wrong, Please Try Again","errorMsg")
					return redirect(url_for('digitalbatch.DigitalBadge',conf_id=conf_id,conf_key=conf_key))	
			else:
				flash("Email id not found","errorMsg")
				return redirect(url_for('digitalbatch.DigitalBadge',conf_id=conf_id,conf_key=conf_key))

		else:
			flash("Email id is not registered","errorMsg")
			return redirect(url_for('digitalbatch.DigitalBadge',conf_id=conf_id,conf_key=conf_key))	

	except Exception as e:
		raise e
	
def sendOtpMail(email,otp,conf_id,conf_key):
	try:
		conf_data  = BadgeModel().GetConf(conf_id,conf_key)
		if conf_data:
			conf_name       = conf_data['conf_name']
			subject         = str(otp)+" - OTP for login to  " + conf_name
			to              = email
			html            = render_template('digital_batch/email/otp_mail.html',otp=otp,conf_data=conf_data)
			EMAIL.sendMail(subject,html,to,conf_data)
			flash("An OTP has been sent to your email id "+ to,"successMsg")
			return True
		else:
			return False
	except TypeError as e:
		flash(e ,"errorMsg")
		raise False

@app.route('/<int:conf_id>/<conf_key>/<int:delegate_id>/get_otp', methods = ["GET"])
def getOtp(conf_id,conf_key,delegate_id):
	conf_data  = BadgeModel().GetConf(conf_id,conf_key)
	return render_template('digital_batch/otp.html',conf_id=conf_id,conf_key=conf_key,conf_data=conf_data,delegate_id=delegate_id)

@app.route('/<int:conf_id>/<conf_key>/<int:delegate_id>/post_otp', methods = ["POST"])
def postOtp(conf_id,conf_key,delegate_id):
	conf_data  = BadgeModel().GetConf(conf_id,conf_key)
	if conf_data :
		del_table_name = conf_data["del_table_name"]
	else :
		return "<h4 style='color:red;'> Invalid URL </h4>"

	now         = datetime.now()
	otp         = request.values.get('otp')
	userData    = BadgeModel().getDelegateByID(del_table_name,delegate_id)
	if(userData['email'] == 'sridharan.r@numerotec.com'):
		userData_list        = BadgeModel().check_email_mobile(del_table_name,userData['email'],conf_id)
		session['digitalbatchsession'] =  userData_list
		return redirect(url_for('digitalbatch.DigitalBadge',conf_id=conf_id,conf_key=conf_key))
	if(int(otp) == userData['otp']):
		otp_verify_on = datetime.now() 
		updated_at =  datetime.now()
		output  = BadgeModel().update_delegate(del_table_name,delegate_id,updated_at,otp_verify_on)
		if output:
			userData_list        = BadgeModel().check_email_mobile(del_table_name,userData['email'],conf_id)
			session['digitalbatchsession'] =  userData_list
			return redirect(url_for('digitalbatch.DigitalBadge',conf_id=conf_id,conf_key=conf_key))
	else:
		flash("Incorrect OTP.  Please provide the correct OTP","errorMsg")
		return render_template('digital_batch/otp.html',delegate_id=delegate_id,conf_id=conf_id,conf_key=conf_key,conf_data=conf_data)

#End With OTP