from flask import request, Blueprint, jsonify, redirect, url_for,flash, render_template,session,json
from core.model.BadgeModel import BadgeModel
from core.model.FoodSessionModel import FoodSessionModel
from core.model.BadgeUserModel import BadgeUserModel

from core.model.ConfModel import ConfModel

from .. import Cryptography
from flask import  app
from random import randint
import datetime
from datetime import timedelta,date,datetime,time
from werkzeug.utils import secure_filename
from os.path import join, dirname, realpath
import os

import pandas as pd
import numpy as np


# from core.library.BackgroundTasks import BackgroundTasks


app = Blueprint('conf', __name__)

@app.route('/<int:conf_id>/<conf_key>/location', methods = ["GET", "POST"])
def Location(conf_id,conf_key):
	return render_template('conference/conference_location_tricon23.html' ,) 

@app.route('/<int:conf_id>/<conf_key>/conf-login', methods = ["GET", "POST"])
def ConfLogin(conf_id,conf_key):
	now       = datetime.now()
	curr_dt   = now.strftime("%Y-%m-%d %H:%M:%S")
	conf_name = None
	get_conf  = BadgeModel().GetConf(conf_id,conf_key)
	if get_conf :
		conf_name = get_conf["conf_name"]
		BadgeUserModel().createConfTables(conf_id,conf_key,curr_dt) 
		if session.get('conf'):
			return redirect(url_for('conf.ConfDashboard' ,conf_id=conf_id,conf_key=conf_key,conf_name=conf_name)) 	
		else:
			return render_template('conference/conf_login.html' ,conf_data = get_conf,conf_id=conf_id,conf_key=conf_key,conf_name=conf_name) 
	else :
		return "<h4 style='color:red;'>Invalid URL </h4>"
		flash("Invalid URL" , "errorMsg")
		return redirect (url_for('conf.ConfLogin',conf_id=conf_id ,conf_key=conf_key))	

@app.route('/conf_post_login', methods = ["POST"])
def ConfPostLogin():
	if request.method =="POST" :
		username  = request.form['username']
		password  = request.form['password']
		conf_id   = request.form['conf_id']
		conf_key  = request.form['conf_key']

		get_conf  = BadgeModel().checkUsername(username,conf_id)
		if get_conf : 
			db_pass =  get_conf['badge_login_password']
			if password == db_pass:
				admin_id = get_conf['conf_id']

				session['conf']   =  get_conf
				encrypted_admin_id = Cryptography.encrypt(conf_id)
				return redirect (url_for('conf.ConfDashboard',conf_id=conf_id ,conf_key = conf_key))
			else:
				flash("Password is mismatch" , "errorMsg")
				return redirect (url_for('conf.ConfLogin',conf_id=conf_id ,conf_key= conf_key))
		else:
			flash("Username is not registered." , "errorMsg")
			return redirect (url_for('conf.ConfLogin',conf_id=conf_id ,conf_key= conf_key))
	else :
		return "Method not allowed"		

@app.route('/<int:conf_id>/<conf_key>/conf-dashboard', methods = ["GET", "POST"])
def ConfDashboard(conf_id,conf_key):
	
	if session.get('conf'):
		conf_data = session.get('conf') 
		conf_name = conf_data['conf_name']
		get_conf  = BadgeModel().GetConf(conf_id,conf_key)
		if get_conf :
			kc_sessions = ConfModel().GetKITSessions(conf_id)
			fc_sessions = ConfModel().GetFCSessions(conf_id)
# 			return "successfully login - conf-dashboard -- IF BLOCK"
			return render_template('conference/conf_dashboard.html',conf_id=conf_id ,conf_key=conf_key,conf_name=conf_name,conf_data = get_conf,kc_sessions= kc_sessions,fc_sessions=fc_sessions)
		else :
			return "successfully login - conf-dashboard -- ELSE BLOCK"
			flash("Invalid Login" , "errorMsg")
			return redirect (url_for('conf.ConfLogin',conf_id=conf_id ,conf_key=conf_key))	
	else:
		# return "successfully login - conf-dashboard -- INVALID SESSIONS"
		flash("Invalid Login" , "errorMsg")
		return redirect (url_for('conf.ConfLogin',conf_id=conf_id ,conf_key=conf_key))


# logout route
@app.route('/<int:conf_id>/<conf_key>/conf-logout', methods = ["GET", "POST"])
def ConfLogout(conf_id,conf_key):
	if session.get('conf'):
		session.pop('conf')
	else : 
		pass
		
	session.pop('_flashes', None)
	return redirect(url_for('conf.ConfLogin',conf_id=conf_id,conf_key=conf_key))			

