from flask import Flask, request, Blueprint, jsonify, redirect, url_for,flash, render_template,session,json

from core.model.KitSessionModel import KitSessionModel

from random import randint
import datetime
 
from datetime import timedelta,date,datetime
# from .. import Cryptography,Auth,RouteGroup
from flask import session, app

from os.path import join


import os
from os import path

app = Blueprint('kit_session', __name__)

@app.route('/<int:conf_id>/<conf_key>/kit_sessionlogin',methods = ["GET", "POST"])
def KitSessionLogin(conf_id,conf_key):
	now = datetime.now()
	current_dt = now.strftime("%Y-%m-%d %H:%M:%S")
	getKcConfData = KitSessionModel().getkcConf(conf_id,conf_key,current_dt)
	if getKcConfData :
		conf_name = getKcConfData["conf_name"]
		if session.get("kitBOsession") :
			return redirect(url_for('kit_session.KitSessionIndex', conf_id=conf_id ,conf_key = conf_key))		    
		else:	
			return render_template('kitsession_counter/kc_session_login_screen.html' ,conf_id=conf_id ,conf_key = conf_key , conf_name =conf_name)
	else :
		return "<h2 style= 'color:red;text-align:center' ; >Invalid URL </h2>"

@app.route('/post_kit_session_login', methods = ["GET","POST"])
def PostKitSessionLogin():
	if request.method == "POST":
		now = datetime.now()
		current_dt = now.strftime("%Y-%m-%d %H:%M:%S")
		user_name     = request.form['user_name']
		password      = request.form['password']
		conf_id       = request.form['conf_id']
		conf_key      = request.form['conf_key']

		if  not user_name  or not password:
			flash('Please enter username and password')
			return redirect (url_for('kit_session.KitSessionLogin' , conf_id = conf_id , conf_key = conf_key))
		else :
			us = KitSessionModel()
			user_output = us.getDataByuser_name(user_name)
			if user_output : 
				db_pass     = user_output['password']
				if password == db_pass:
					kc_user_id = user_output['kc_user_id']
					us.updateKITLoginTime(kc_user_id,current_dt);
					session["kitBOsession"] = user_output
					flash('Login Successfully  ! ', "successMsg" )
					return redirect (url_for('kit_session.KitSessionIndex', conf_id = conf_id , conf_key = conf_key)) 
				else : 
					flash('Passsword invalid. Please check the password.  ',"errorMsg" )
					return redirect (url_for('kit_session.KitSessionLogin' , conf_id = conf_id , conf_key = conf_key))
			else:
				flash("Username is not registered.","errorMsg" )
				return redirect (url_for('kit_session.KitSessionLogin' , conf_id = conf_id , conf_key = conf_key))
	else :
		return redirect (url_for('kit_session.KitSessionLogin' , conf_id = conf_id , conf_key = conf_key))

@app.route('/<int:conf_id>/<conf_key>/kitsession_logout',methods = ["GET", "POST"])
def KitSessionLogout(conf_id,conf_key):
	if session.get("kitBOsession") :
		session.pop('kitBOsession', None)
		flash("logout Successfully","successMsg")
	else :
		pass
	return redirect(url_for('kit_session.KitSessionLogin',conf_id = conf_id ,conf_key = conf_key))		    

@app.route('/<int:conf_id>/<conf_key>/kit_session_index',methods = ["GET", "POST"])
def KitSessionIndex(conf_id,conf_key):
	getKcConfData = KitSessionModel().getKcConfData(conf_id,conf_key)
	if getKcConfData :
		conf_name = getKcConfData["conf_name"]
		if session.get("kitBOsession") :
			get_data = KitSessionModel().getSessionData(conf_id,conf_key)
			html_data = render_template('kitsession_counter/kit_session_table.html' , r_data =get_data)
			return render_template('kitsession_counter/kit_session_index.html' ,html_data = html_data ,conf_id =conf_id ,conf_key =conf_key,conf_name=conf_name)
		else :
			flash("Invalid login" , "errorMsg")
			return redirect (url_for('kit_session.KitSessionLogin',conf_id=conf_id ,conf_key=conf_key))	
	else :
		return "<h2 style= 'color:red;text-align:center' ; > Invalid Login </h2>"			


@app.route('/post_kit_session', methods = ["POST"])
def PostKitSession():
	if session.get("kitBOsession") :
		now = datetime.now()
		current_dt   = now.strftime("%Y-%m-%d %H:%M:%S")
		session_name = request.form['session_name']
		session_key  = request.form['session_key']
		start_time   = request.form['start_time']
		end_time     = request.form['end_time']
		conf_id      = request.form['conf_id']
		conf_key     = request.form['conf_key']
		# fetching data from form..
		data = {
			'session_name' : session_name,
			'session_key'  : session_key,
			'start_time'   : start_time,
			'end_time'     : end_time,
			'created_at'   : current_dt,
			'conf_id'      : conf_id,
			'conf_key'     : conf_key
		}
		insert_kitbo = KitSessionModel().insert_kitdata_and_getdata(data,conf_id,conf_key)
		html_data = render_template('kitsession_counter/kit_session_table.html',r_data =insert_kitbo)
		data = {"html_data" : html_data ,"status" : 1 , "msg" : "success"}
		return json.dumps(data)
	else:
		return json.dumps(data)


@app.route('/edit_kit_session_index',methods = ["GET","POST"])
def EditKitSessionIndex():
	session_id = request.values.get("session_id")
	kit_data = KitSessionModel().edit_kitbo(session_id) 
	if kit_data :
		data = {'kit_data' :kit_data ,'msg' : 'success' ,'status' : 1}
	else :
		data = {'kit_data' :[] ,'msg' : 'data not exist' ,'status' : 2} 

	return json.dumps(data,default=str)


@app.route('/update_kit_session_index', methods = ["POST"])
def UpdateKitSessionIndex():
	now = datetime.now()
	current_dt = now.strftime("%Y-%m-%d %H:%M:%S")
	session_name = request.values.get("session_name")  or None
	session_key = request.values.get("session_key")  or None
	start_time = request.values.get("start_time")  or None
	end_time  = request.values.get("end_time")  or None
	session_id = request.values.get("session_id")  or None
	conf_id = request.values.get("conf_id")
	conf_key = request.values.get("conf_key")


	if session_id and int(session_id) > 0 :
		data_for_update = {
		'session_name' : session_name,
		'session_key'  : session_key,
		'start_time'   : start_time,
		'end_time'     : end_time,
		'updated_at'   : current_dt
		}
		update_and_getdata = KitSessionModel().update_kitbo_and_getdata(data_for_update,session_id,conf_id,conf_key)
		html_data = render_template('kitsession_counter/kit_session_table.html',r_data =update_and_getdata)
		data = {"html_data" : html_data ,"status" : 1 , "msg" : "success"}
	else:
		data = {"html_data" : "" ,"status" : 2 , "msg" : "Invalid Session"}	

	return json.dumps(data)

# update_start_time	
@app.route('/update_kitstart_time', methods = ["GET", "POST"])
def UpdateKitStartTime():
	now = datetime.now()
	current_dt  = now.strftime("%Y-%m-%d %H:%M:%S")
	curr_dt_dateformat = datetime.strptime(current_dt, "%Y-%m-%d %H:%M:%S")
	session_id  = request.values.get('session_id') or None
	conf_id = request.values.get("conf_id")
	conf_key = request.values.get("conf_key")
	if session_id and int(session_id) > 0 :
		data_for_update = {
		'start_time' : current_dt,
		'updated_at' : current_dt,
		'is_active'  : 1
		}
		update_and_getdata = KitSessionModel().update_kitbo_and_getdata(data_for_update,session_id,conf_id,conf_key)
		html_data = render_template('kitsession_counter/kit_session_table.html',r_data =update_and_getdata, curr_dt_dateformat=curr_dt_dateformat)
		data = {"html_data" : html_data ,"status" : 1 , "msg" : "success"}
		return json.dumps(data)
	else :
		data = {"html_data" :[''],'status' : 2 ,"msg" : "Invalid session ID"}
		return "Invalid Login"	

# update_end_time	
@app.route('/update_kitend_time', methods = ["GET", "POST"])
def UpdateKitEndTime():
	now = datetime.now()
	current_dt  = now.strftime("%Y-%m-%d %H:%M:%S")
	session_id  = request.values.get('session_id') or None
	conf_id = request.values.get("conf_id")
	conf_key = request.values.get("conf_key")
	if session_id and int(session_id) > 0 :
		data_for_update = {
		'end_time'   : current_dt,
		'updated_at' : current_dt,
		'is_active'  : 0
		}
		update_and_getdata = KitSessionModel().update_kitbo_and_getdata(data_for_update,session_id,conf_id,conf_key)
		html_data = render_template('kitsession_counter/kit_session_table.html',r_data =update_and_getdata)
		data = {"html_data" : html_data ,"status" : 1 , "msg" : "success"}
		return json.dumps(data)
	else :
		data = {"html_data" :[''],'status' : 2 ,"msg" : "Invalid session ID"}
		return "Invalid Login"
	
@app.route('/delete_kit_session_index',methods = ["GET","POST"])
def DeleteKitsessionIndex():
	session_id    = request.values.get('session_id')
	delet_data = KitSessionModel().delete_kit_session_index(session_id)
	html_data = render_template('kitsession_counter/kit_session_table.html',r_data =delet_data)
	data = {"html_data" : html_data ,"status" : 1 , "msg" : "success"}
	return json.dumps(data)		
	